﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace OrderSystemDAL
{
    public static class UserAccountsData
    {
        public static int Insert(string firstName, string lastName, DateTime insertDate)
        {
            using (OrderSystemEntities db = new OrderSystemEntities())
            {
                return Insert(db, firstName, lastName, insertDate);
            }
        }

        public static int Insert(OrderSystemEntities db, string firstName,
                                 string lastName, DateTime insertDate)
        {
            return db.UserAccounts_Insert(firstName, lastName, insertDate, insertDate).ElementAt(0).Value;
        }

        public static void Update(int id, string firstName, string lastName,
                                  DateTime updateDate)
        {
            using (OrderSystemEntities db = new OrderSystemEntities())
            {
                Update(db, id, firstName, lastName, updateDate);
            }
        }

        public static void Update(OrderSystemEntities db, int id, string firstName,
                                  string lastName, DateTime updateDate)
        {
            db.UserAccounts_Update(id, firstName, lastName, updateDate);
        }

        public static void Delete(int id)
        {
            using (OrderSystemEntities db = new OrderSystemEntities())
            {
                Delete(db, id);
            }
        }

        public static void Delete(OrderSystemEntities db, int id)
        {
            db.UserAccounts_Delete(id);
        }

        public static UserAccount SelectById(int id)
        {
            using (OrderSystemEntities db = new OrderSystemEntities())
            {
                return SelectById(db, id);
            }
        }

        public static UserAccount SelectById(OrderSystemEntities db, int id)
        {
            return db.UserAccounts_SelectById(id).ElementAtOrDefault(0);
        }

        public static List<UserAccount> SelectAll()
        {
            using (OrderSystemEntities db = new OrderSystemEntities())
            {
                return SelectAll(db);
            }
        }

        public static List<UserAccount> SelectAll(OrderSystemEntities db)
        {
            return db.UserAccounts_SelectAll().ToList();
        }
    }
}
