﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using OrderSystemBLL;
using System.Collections;

namespace OrderSystemUI
{
    public partial class Users : System.Web.UI.Page
    {


        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                LoadUserDropDownList();
            }
        }

        private void LoadUserDropDownList()
        {
            ddlUsers.DataSource = UserAccountEO.SelectAll();

            ddlUsers.DataTextField = "FullName";
            ddlUsers.DataValueField = "Id";
            ddlUsers.DataBind();

            ddlUsers.Items.Insert(0, new ListItem("Create New User", ""));
        }

        protected void btnSave_Click(object sender, EventArgs e)
        {
            ArrayList validationErrors = new ArrayList();
            UserAccountEO userAccount = new UserAccountEO();

            if (ddlUsers.SelectedItem.Value != "")
            {
                //Updating
                userAccount.Id = Convert.ToInt32(ddlUsers.SelectedValue);
            }

            userAccount.FirstName = txtFirstName.Text;
            userAccount.LastName = txtLastName.Text;

            userAccount.Save(ref validationErrors);

            if (validationErrors.Count > 0)
            {
                ShowValidationMessages(validationErrors);
            }
            else
            {
                //Reload the drop down list
                LoadUserDropDownList();

                //Select the one the user just saved.
                ddlUsers.Items.FindByValue(userAccount.Id.ToString()).Selected = true;

                lblErrorLabel.Visible = false;
                lblErrorMessages.Visible = false;
            }

        }
        private void ShowValidationMessages(ArrayList validationErrors)
        {
            if (validationErrors.Count > 0)
            {
                lblErrorLabel.Visible = true;
                lblErrorMessages.Visible = true;
                lblErrorMessages.Text = "<br />";

                foreach (string message in validationErrors)
                {
                    lblErrorMessages.Text += message + "<br />";
                }
            }
            else
            {
                lblErrorLabel.Visible = false;
                lblErrorMessages.Visible = false;
            }
        }

        protected void ddlUsers_SelectedIndexChanged(object sender, EventArgs e)
        {
            txtFirstName.Text = "";
            txtLastName.Text = "";
            lblInserted.Text = "";
            lblUpdated.Text = "";

            if (ddlUsers.SelectedValue != "")
            {
                int userAccountId = Convert.ToInt32(ddlUsers.SelectedValue);

                UserAccountEO userAccount = new UserAccountEO();
                if (userAccount.Select(userAccountId))
                {
                    txtFirstName.Text = userAccount.FirstName;
                    txtLastName.Text = userAccount.LastName;
                    lblInserted.Text = userAccount.InsertDate.ToString();
                    lblUpdated.Text = userAccount.UpdateDate.ToString();
                }
            }
        }

        protected void btnDelete_Click(object sender, EventArgs e)
        {
            if (ddlUsers.SelectedItem.Value != "")
            {
                ArrayList validationErrors = new ArrayList();
                UserAccountEO userAccount = new UserAccountEO();

                userAccount.Id = Convert.ToInt32(ddlUsers.SelectedValue);
                userAccount.Delete(ref validationErrors);

                if (validationErrors.Count > 0)
                {
                    ShowValidationMessages(validationErrors);
                }
                else
                {
                    LoadUserDropDownList();
                    txtFirstName.Text = "";
                    txtLastName.Text = "";
                    lblInserted.Text = "";
                    lblUpdated.Text = "";
                    lblErrorLabel.Visible = false;
                    lblErrorMessages.Visible = false;
                }
            }

        }
    }
}